/*
	execf cut|select f args
	man 1 cut. field specifier looks like that. acts like it for "cut" else acts like "select".
	#maybe mselect mult. select exec's each range

	execf expand args
	expand is like "eval cmd $(cmd|args) a2 a3", so translates lines to args

	execf pid file args
	write pid to file, then exec args (cmd is arg1)

	execf c sh_name args
	concat. with a space args and pass to "sh -c "
	#like exec1(){ sh -c 'eval "$@"' a "$@";}
	#todo maybe auto-quote spaces and backslash\

	execf f|ff args
	link to bin/ff (ff.sh outdated)
	list ;, escaped by \ (vs / or null) (maybe add option to use ())
	arg. break viewed as a special char.
	parallel lists combined, if len=1 repeat, if past list end blank string, stop at end of longest list
	if "ff" 1st arg is field specifier, of args to quote any ;,
	#prob. not expand2 f $(quote_fe args) $(quote_e args) $(quote_fe args)
	#maybe use 1 list and eliminate "cut_esc2"

	when using lines not using escapes, with commas use escapes
	see also cmds. feedpaste and teeval
*//*
examples:
# xclip -o|grep -ie execf|cut -f2- -d\#|xclip -sel clip
 execf select '1-3,5-' echo a b c d e
 execf select '1-3,5-' echo a b c
 execf expand echo $(args a b c)
 execf f =,file\; execf.c
 execf f = $({ = 1;= 2;= 3;}|nel -d|tr $'\n' ,) ' 'x
	now execf f = \;$({ = 1;= 2;= 3;}|nel -d|tr $'\n' ,)\;x
# execf pid /tmp/sleep1.pid sleep 300
# kill $(cat /tmp/sleep1.pid) #in another term.
*/
void torange(int *out,char *s)
	char *field=s,*dash=strchr(field,'-'),*end=strchr(field,'\0')
	str_replace_c(field,'-','.',3)
	int f1=0,f2=0
	if(dash)
		dash[0]='\0'
		if(dash-field>0)f1=fromstr(field)
		if(end-(dash+1)>0)f2=fromstr(dash+1)
		dash[0]='.'
	else
		if(end-field>0)f1=f2=fromstr(field)
	str_replace_c(field,'-','.',3)
	out[0]=f1;out[1]=f2
void adjust_range(int *range,int min_v,int max_v)
	int f1=range[0],f2=range[1]
	if(f1==0)f1=min_v;if(f2==0)f2=max_v
	if(f1<0)f1+=max_v+1;if(f2<0)f2+=max_v+1
	if(f1<min_v)f1=min_v;if(f2>max_v)f2=max_v
	/*valid if f1<=f2*/
	range[0]=f1;range[1]=f2
//typedef tlist_t(char **) tlist_t_charp
char execut=0
int main(int argc,char **argv)
	int argn=1
	if(argn<argc);else return 1
	int cmd=strlistfindn_off(list("select","cut","expand","pid","c","f"),argv[argn],strlen(argv[argn]))
	if(cmd<0)
		dprintf(2,"sub-command not found\n");return 1
	else if(cmd==1){execut=1;cmd=0;}
	argn+=1
	tlist_t_charp av;av.a=0;av.len=0
	if(cmd==0)
		if(argc<4) return 1
		char *field=strdup(argv[2])
		char *argm;if(!execut)
			argm=malloc(sizeof(char)*argc)
			memset(argm,0,sizeof(char)*argc)
		int n=1;while(1)
			char *s=echeck(cut(field,n,','));if(!s)break
			int r[2];torange(r,s);free(s)
			adjust_range(r,1,argc-3)
			if(1)
				int f1=r[0],f2=r[1]
				while(f1<=f2)
					if(!execut)argm[f1+2]=1;else tlistpe(av,argv[f1+2]);f1+=1
			n+=1
		free(field)
		if(!execut)
			n=3;while(n<argc)
				if(argm[n])
					tlistpe(av,argv[n])
				n+=1
			free(argm)
	else if(cmd==2)
		int n=argn;while(n<argc)
			char *s=argv[n];char eol[]={'\r','\n'};while(1)
				char *line=strreadline_dup(&s,eol);if(!line)break
				tlistpe(av,line)
			n+=1
	else if(cmd==3)
		if(argn<argc)
			char *fn=argv[argn];argn+=1
			int fd=open(fn,O_WRONLY|O_CREAT|O_TRUNC);if(fd>=0)
				dprintf(fd,"%lld",(llong)getpid());close(fd)
			while(argn<argc)
				tlistpe(av,argv[argn]);argn+=1
	else if(cmd==4)
		tlistpe(av,(argc>2)?argv[2]:"sh","-c")
		char *arg=zmalloc(1);char first=1
		int n=3;while(n<argc)
			if(!first)strpe_c(arg,' ');strpe(arg,argv[n]);n+=1;first=0
		tlistpe(av,arg)
	else if(0&&cmd==5)
		char any;int f=1;while(1)
			any=0
			int n=argn;while(n<argc)
				char *s=argv[n];char next=1;if(s[0]==' ')
					next=0;s+=1
				char *s2=cut_esc(s,f,',');if(s2)any=1;else
					s2=cut_esc(s,2,',');if(!s2)s2=strdup(s);else
						freez(s2)
				if(s2)
					if(next||av.len<1)tlistpe(av,s2)
					else{strpe(av.a[av.len],s2);free(s2);}
				n+=1
			if(!any)break
			/*exec*/
			if(av.len)
				tlistpe(av,NULL)
				pid_t pid=fork(),pid2;int ex;if(!pid)
					execvp(av.a[1],av.a+1);exit(1)
				else if(pid>0)
					pid2=wait(&ex)
			/*free*/
			n=1;while(n<av.len)
				free(av.a[n]);n+=1
			av.len=0
			f+=1
	else if(cmd==5)
		tlist_t_charp av2={.a=0,.len=0}
		tlist_t_int av2_e={.a=0,.len=0}
		char *av2o=zmalloc(1);char *sep=" ";char first=1
		int n=argn;while(n<argc)
			int len=strlen(argv[n])
			int e_off=av2_e.len<1?0:av2_e.a[av2_e.len]
			if(!first)tlistpe(av2,sep);tlistpe(av2,argv[n])
			e_off+=(!first?1:0);if(!first)tlistpe(av2_e,e_off);e_off+=len;tlistpe(av2_e,e_off)
			if(!first)strpe_c(av2o,'.');strpe(av2o,argv[n]);int n2=1;while(n2<=len){av2o[e_off-n2]=' ';n2+=1;}
			n+=1;first=0
		tlist_t_charp l={.a=0,.len=0};if(1)
			int f=1;while(1)
				char *out2,*out;out=cut_esc2(av2,av2_e,catstr1(av2o),catstr1_e(av2o),f,';',&out2);if(!out)break
				tlistpe(l,out,out2) ;f+=1
		char any;int f=1;while(1)
			any=0;char *cmd=zmalloc(1),*cmd_o=zmalloc(1)
			int n=1;while(n<=l.len)
				char *s3,*s2=cut_esc2(catstr1(l.a[n]),catstr1_e(l.a[n]),catstr1(l.a[n+1]),catstr1_e(l.a[n+1]),f,',',&s3);if(s2)any=1;else
					s2=cut_esc2(catstr1(l.a[n]),catstr1_e(l.a[n]),catstr1(l.a[n+1]),catstr1_e(l.a[n+1]),2,',',&s3);if(!s2){s2=strdup(l.a[n]);s3=strdup(l.a[n+1]);}else
						freez(s2);free(s3)
				if(s2)
					strpe(cmd,s2);strpe(cmd_o,s3)
					free(s2);free(s3)
				n+=2
			if(1)
				char *a=cmd_o,*a1=a,*s=a;while(1)
					if(!*a||*a=='.')
						tlistpe(av,strndup(cmd+(s-a1),a-s));s=a+1
					if(!*a)break;a+=1
				free(cmd);free(cmd_o)
			if(!any)break/*fixme free here*/
			/*exec*/
			if(av.len)
				tlistpe(av,NULL)
				pid_t pid=fork(),pid2;int ex;if(!pid)
					execvp(av.a[1],av.a+1);exit(1)
				else if(pid>0)
					pid2=wait(&ex)
			/*free*/
			n=1;while(n<av.len)
				free(av.a[n]);n+=1
			av.len=0
			f+=1
		/*more free here*/
	if(av.len&&cmd!=5)
		tlistpe(av,NULL)
		execvp(av.a[1],av.a+1)
	return 0
//cpp.py execf;gcc execf.c -o /root/bin/execf -Wimplicit-function-declaration -Wreturn-type -Dlist_version1 -include syslib.h -l:listlib.a